unit FmfMap;

{-----------------------------------------------------------------------------
TFmfMap̎g

procedure TForm1.FormPaint(Sender: TObject);
var
  map: TFmfMap;
  i, x, y: Integer;
begin

  map := TFmfMap.Create('test.fmf');
  if not map.IsOpen then Exit;

  // ܂
  // map := TFmfMap.Create;
  // if not map.Open('test.fmf') then Exit;

  for i := 1 to map.LayerCount - 1 do begin
    for y := 0 to map.Height - 1 do begin
      for x := 0 to map.Width - 1 do begin
        with Canvas do begin
          Canvas.TextOut(x * 32, y * 32, IntToStr(map.GetValue(i, x, y)));
        end;
      end;
    end;
  end;

  map.Free;
end;

------------------------------------------------------------------------------}

interface

uses
  SysUtils, Classes;

{-----------------------------------------------------------------------------
  FMFt@Cwb_[(20byte)
------------------------------------------------------------------------------}
type TFmfHeader = packed Record
  identifier: LongWord;		// t@C^Cvʎq '_FMF'
  size:		    LongWord;		// TCY
	width:	    LongWord;		// }bv̉
  height:     LongWord;		// }bv̏c
  cWidth:	    Byte;       // `bv̉
  cHeight:	  Byte;       // `bv̏c
  layerCount: Byte;				// C[̐
  bitCount: 	Byte;				// f[^̃rbgJEg
  end;

{------------------------------------------------------------------------------
  TFmfMap
------------------------------------------------------------------------------}
type TFmfMap = class(TObject)
  constructor Create(); overload;
  constructor Create(const path: string); overload;
  destructor Free();

  function Open(const path: string): Boolean;
  function IsOpen(): Boolean;
  procedure Close();

  function GetValue(layerIndex:Byte; x, y:LongWord): Integer;
  procedure SetValue(layerIndex:Byte; x, y:LongWord; value: Integer);

  function GetLayer(layerIndex:Byte): Pointer;

  private
    FHeader: TFmfHeader;
    Data: Array of Byte;

  published
    property Width:       LongWord read FHeader.width;
    property Height:      LongWord read FHeader.height;
    property ChipWidth:   Byte read FHeader.cWidth;
    property ChipHeight:  Byte read FHeader.cHeight;
    property LayerCount:  Byte read FHeader.layerCount;
    property BitCount:    Byte read FHeader.bitCount;

  end;

implementation

{------------------------------------------------------------------------------
  RXgN^
------------------------------------------------------------------------------}
constructor TFmfMap.Create();
begin
end;
constructor TFmfMap.Create(const path: string);
begin
  Open(path);
end;

{------------------------------------------------------------------------------
  fXgN^
------------------------------------------------------------------------------}
destructor TFmfMap.Free();
begin
  Close;
end;


{------------------------------------------------------------------------------
  }bvJ
------------------------------------------------------------------------------}
function TFmfMap.Open(const path: string): Boolean;
 var
  stream: TFileStream;
  layerSize: LongWord;
  elemSize: LongWord;
begin

  Close;

  try
    stream := TFileStream.Create(path, fmOpenRead);
    stream.ReadBuffer(FHeader, sizeof(TFmfHeader));

    if FHeader.identifier <> $5F464D46 then begin
      Result := False;
      Exit;
    end;

    elemSize := FHeader.bitCount div 8;
    layerSize := FHeader.width * FHeader.height * FHeader.layerCount * elemSize;
    SetLength(Data, layerSize);

    stream.ReadBuffer(Data[0], layerSize);

  finally
    stream.Free;
  end;

  Result := True;
end;
{------------------------------------------------------------------------------
  }bvJĂ邩?
------------------------------------------------------------------------------}
function TFmfMap.IsOpen(): Boolean;
begin
  Result := (Length(Data) > 0);
end;
{------------------------------------------------------------------------------
  }bv
------------------------------------------------------------------------------}
procedure TFmfMap.Close();
begin
  Finalize(Data);
  FillChar(FHeader, sizeof(FHeader), 0);
end;

{------------------------------------------------------------------------------
  wW̃}bvl擾
------------------------------------------------------------------------------}
function TFmfMap.GetValue(layerIndex:Byte; x, y:LongWord): Integer;
var
  layerPos: Integer;
  pBLayer: PByteArray;
  pWLayer: PWordArray;
begin

  if (layerIndex >= FHeader.layerCount) or
     (x >= FHeader.width) or
     (y >= FHeader.height) then begin
    {̊֐̖߂lz̓YƂĒڎgȂ
    G[R[hƂ0ԂS}
    Result := -1;
    Exit;
  end;

  layerPos := FHeader.width * FHeader.height * layerIndex * FHeader.bitcount div 8;

  if FHeader.bitCount = 8 then begin
    pBLayer := @Data[layerPos];
    Result := pBLayer[y * FHeader.width + x];
  end else begin
    pWLayer := @Data[layerPos];
    Result := pWLayer[y * FHeader.width + x];
  end;

end;

{------------------------------------------------------------------------------
  wW̃}bvlݒ
------------------------------------------------------------------------------}
procedure TFmfMap.SetValue(layerIndex:Byte; x, y:LongWord; value: Integer);
var
  layerPos: Integer;
  pBLayer: PByteArray;
  pWLayer: PWordArray;  
begin
  if (layerIndex >= FHeader.layerCount) or
     (x >= FHeader.width) or
     (y >= FHeader.height) then Exit;

  layerPos := FHeader.width * FHeader.height * layerIndex * FHeader.bitcount div 8;

  if FHeader.bitCount = 8 then begin
    pBLayer := @Data[layerPos];
    pBLayer[y * FHeader.width + x] := value;
  end else begin
    pWLayer := @Data[layerPos];
    pWLayer[y * FHeader.width + x] := value;
  end;

end;

{------------------------------------------------------------------------------
  w背C[̃|C^ʒu擾
------------------------------------------------------------------------------}
function TFmfMap.GetLayer(layerIndex:Byte): Pointer;
begin
  if layerIndex >= FHeader.layerCount then
    Result := nil
  else
    Result := @Data[FHeader.width * FHeader.height * layerIndex * FHeader.bitcount div 8];
end;

end.
